## README

This directory contains programs which will take the output of ConcBugAssist
and automatically repair a program. 

### Building

There are two programs to build: EdgeMaker and EdgeFixer.

Both require `GHC` (Glorious Glasgow Haskell Compiler) and `cabal`. They were
tested using GHC version 7.6.3 and cabal version 1.18.0.3. Older versions of
cabal do not support sandboxes and will not work (guaranteed not to be working
on Ubuntu 12.04).

EdgeMaker parses the output of CBMC and determines what modifications should be
made to the program. EdgeFixer performs the actual modifications.

Both programs require GHC (tested with version 7.6.3) and cabal.

The Makefile in this directory should build both programs:

    make
