// Author: Markus Kusano
//
// A sequential counter used in a concurrent setting
//
// Adapted from Art of Multiprocessor Programming
#include <stdlib.h>
#include <pthread.h>

int count;

void *t1_main() {
  int tmp = count;
  tmp += 1;
  count = tmp;
  return NULL;
}

void *t2_main() {
  int tmp = count;
  tmp += 1;
  count = tmp;
  return NULL;
}

int main() {
  count = 0;
  pthread_t t1;
  pthread_t t2;

  pthread_create(&t1, NULL, t1_main, NULL);
  pthread_create(&t2, NULL, t2_main, NULL);

  pthread_join(t1, NULL);
  pthread_join(t2, NULL);

  if (count != 2) {
    assert(0);
  }

  return 0;
}
