/**
 * \file
 * \author Markus Kusano (mukusano@vt.edu)
 *
 */
#include <assert.h>
#include <pthread.h>
#include <stdbool.h>

// Booleans to represent the state of the file
bool renamed;
bool removed;
char data;


/**
 * Opens a file with write permission with the file writes some
 * information to it and then attempts to rename and remvoe the temporary file.
 *
 * \param args Unused
 * \return Returns NULL upon completion
 */
void *t1_main(void *args);

/**
 * Opens a file with , writes some information to it and then attempts to
 * rename and remvoe the temporary file.
 *
 * \param args Unused
 * \return Returns NULL upon completion
 */
void *t2_main(void *args);

void *t1_main(void *args) {
    // write some data
    data = 'a'; 

    // rename the file
    renamed = true;

    // remove the temporary file
    if (removed) {
      assert(0);
    }
    removed = true;

    return NULL;
}

void *t2_main(void *args) {
    // write some data
    data = 'a'; 

    // rename the file
    renamed = true;

    // remove the temporary file
    if (removed) {
      assert(0);
    }
    removed = true;

    return NULL;
}

/**
 * Spawns threads into t1_main() and t2_main()
 *
 * Returns NULL upon completion.
 */
int main(void) {
    pthread_t t1, t2;

    // initialize everything
    renamed = false;
    removed = false;
    data = 'x';

    pthread_create(&t1, NULL, t1_main, NULL);
    pthread_create(&t2, NULL, t2_main, NULL);

    pthread_join(t1, NULL);
    pthread_join(t2, NULL);

    return 0;
}
