/*******************************************************************\

Module: Traces of GOTO Programs

Author: Daniel Kroening

Date: July 2005

\*******************************************************************/

#ifndef CPROVER_GOTO_SYMEX_BUILD_GOTO_TRACE_H
#define CPROVER_GOTO_SYMEX_BUILD_GOTO_TRACE_H

#include "symex_target_equation.h"
#include "goto_symex_state.h"

void build_goto_trace(
  const symex_target_equationt &target,
  prop_convt &prop_conv, /*SEPI*/	//  const prop_convt &prop_conv, ==> to be able to call prop_conv.write_to_file()
  const namespacet &ns,
  goto_tracet &goto_trace,
  std::vector<int> input_arg_vars);

#endif
