#include <pthread.h>

// Coefficients of the equation
int c0;
int c1;
int c2;
int c3;

// Input tuple
int var0;
int var1;
int var2;
int var3;

// intermediate products
int p0 = 0;
int p1 = 0;
int p2 = 0;
int p3 = 0;

int result = 0;

void *thread1(void *args) {
	
	int local1 = 0;
	
	local1 = p0;
	if(p0==0) {
	  local1 = var0 * c0;
	}
	p0 = local1;
	
	local1 = p1;
	if(p1==0) {
	  local1 = var1 * c1;
	}
	p1 = local1;
	
	local1 = p2;
	if(p2==0) {
	  local1 = var2 * c2;
	}
	p2 = local1;

	local1 = p3;
	if(p3==0) {
	  local1 = var3 * c3;
	}
	p3 = local1;
  		
    	int tmp1 = p0;
	tmp1 = tmp1 + p1;
	tmp1 = tmp1 + p2;
	result = tmp1 + p3;
	return NULL;
}

void *thread2(void *args) {
	
	int local2 = 0;
	
	local2 = p0;
	if(p0==0) {
	  local2 = var0 * c0;
	}
	p0 = local2;
	
	local2 = p1;
	if(p1==0) {
	  local2 = var1 * c1;
	}
	p1 = local2;
	
	local2 = p2;
	if(p2==0) {
	  local2 = var2 * c2;
	}
	p2 = local2;

	local2 = p3;
	if(p3==0) {
	  local2 = var3 * c3;
	}
	p3 = local2;

       	int tmp2 = p0;
	tmp2 = tmp2 + p1;
	tmp2 = tmp2 + p2;
	result = tmp2 + p3;
	return NULL;
}

void main() {
  var0 = 2;
  var1 = 3;
  var2 = -5;
  var3 = 10;
  c0 = 4;
  c1 = 8;
  c2 = 12;
  c3 = 1;
  pthread_t t1;
  pthread_t t2;

  pthread_create(&t1, NULL, thread1, NULL);
  pthread_create(&t2, NULL, thread2, NULL);

  pthread_join(t1, NULL);
  pthread_join(t2, NULL);

//  if (result != p0) {
//    assert(0);
//  }
  int tmp3 = p0;
  tmp3 = tmp3 + p1;
  tmp3 = tmp3 + p2;
  tmp3 = tmp3 + p3;
  assert(result == tmp3);

  return;
}
