#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>

#define USAGE "./reorder <param1> <param2>\n"
//#define ISET 2
//#define ICHECK 2
static int iSet = 2;
static int iCheck = 2;

static int a = 0;
static int b = 0;

void *setThread1(void *param);
void *setThread2(void *param);
void *checkThread1(void *param);
void *checkThread2(void *param);
void set();
int check();

int main(int argc, char *argv[]) {
    int i, err;
  
    pthread_t setPool[iSet];
    pthread_t checkPool[iCheck];

    /*
    for (i = 0; i < iSet; i++) {
        if (0 != (err = pthread_create(&setPool[i], NULL, &setThread, NULL))) {
            fprintf(stderr, "Error [%d] found creating set thread.\n", err);
            exit(-1);
        }
    }
    */
    pthread_create(&setPool[0], NULL, &setThread1, NULL);
    pthread_create(&setPool[1], NULL, &setThread2, NULL);

    /*
    for (i = 0; i < iCheck; i++) {
        if (0 != (err = pthread_create(&checkPool[i], NULL, &checkThread,
                                       NULL))) {
            fprintf(stderr, "Error [%d] found creating check thread.\n", err);
            exit(-1);
        }
    }
    */
    pthread_create(&checkPool[0], NULL, &checkThread1, NULL);
    pthread_create(&checkPool[1], NULL, &checkThread2, NULL);

    /*
    for (i = 0; i < iSet; i++) {
        if (0 != (err = pthread_join(setPool[i], NULL))) {
            fprintf(stderr, "pthread join error: %d\n", err);
            exit(-1);
        }
    }
    */
    pthread_join(setPool[0], NULL);
    pthread_join(setPool[1], NULL);

    /*
    for (i = 0; i < iCheck; i++) {
        if (0 != (err = pthread_join(checkPool[i], NULL))) {
            fprintf(stderr, "pthread join error: %d\n", err);
            exit(-1);
        }
    }
    */
    pthread_join(checkPool[0], NULL);
    pthread_join(checkPool[1], NULL);

    return 0;
}
        
void *setThread1(void *param) {
    a = 1;
    b = -1;

    return NULL;
}

void *setThread2(void *param) {
    a = 1;
    b = -1;

    return NULL;
}

void *checkThread1(void *param) {
    //assert(((a == 0 && b == 0) || (a == 1 && b == -1)));
    if (! ((a == 0 && b == 0) || (a == 1 && b == -1))) {
      assert(0);
    }

    return NULL;
}

void *checkThread2(void *param) {
    //assert(((a == 0 && b == 0) || (a == 1 && b == -1)));
    if (! ((a == 0 && b == 0) || (a == 1 && b == -1))) {
      assert(0);
    }

    return NULL;
}
