#!/bin/sh

# Run all tests
TEST_DIRS="
  boop_simple_vf_false \
  testconc02 \
  fibbench_false \
  fibbench_longer_false \
  reorder2_false \
  account_false \
  read_write_false \
  lazy01_false \
  lineEq_2t_01 \
  VectPrime02 \
  mysql5 \
  mysql-12848 \
  mysql-3596 \
  mysql-644 \
  apache-21287 \
  apache-25520 \
  freebsd_auditarg \
  cherokee_01 \
  llvm-8441 \
  gcc-java-25530 \
  gcc-libstdc++-3584 \
  gcc-libstdc++-21334 \
  gcc-libstdc++-40518/ \
  linux-tg3 \
  linux-iio \
  transmission-1.42 \
  glib-512624_02 \
  jetty-1187 \
  mozilla-61369 \
  hash_table \
  list_seq \
  counter_seq \
  ms_queue02 \
  barrier_vf_false"


  # passing but not in table
#ms_queue03 \

# these tests are failing
# pthread_1_vs_false \
# stateful01_false \

for d in $TEST_DIRS
do
  ./test.sh $d || exit 1
done
